Subject: Re: [POWERPC] mark BUG() as noreturn

From: Amos Waterland <[email-masked]>
Date: Thu, 21 Sep 2006 21:34:22 -0400

On Fri, Sep 22, 2006 at 10:54:05AM +1000, Michael Ellerman wrote:
> On Thu, 2006-09-21 at 08:18 -0400, Jimi Xenidis wrote:
> > But BUG() _can_ return, if I have a probe, xmon or kgdb configured it  
> > is possible  to play with the state of the world and try to continue/ 
> > recover, (xmon "x" command).  IMHO, this is a powerful debugging  
> > scenario.
> 
> Hmm, ok I hadn't thought of that. Personally I've never tried to recover
> from a BUG(), do people really do that much?

Yes, people do that.  

Especially in the case where you have a bug that only manifests every so
often: you want to capitalize on the fact that you have caught the
machine in that state.

You aren't trying to recover as though nothing has happened, but you are
trying to continue execution to learn about things now that you know the
machine was in the state that triggers the bug.